Package org.springframework.cglib.transform

# Class ClassVisitorTee

java.lang.Object
org.springframework.asm.ClassVisitor
org.springframework.cglib.transform.ClassVisitorTee

public class ClassVisitorTee extends ClassVisitor

## Field Summary

### Fields inherited from class org.springframework.asm.ClassVisitor

`api, cv`

## Constructor Summary

Constructors
Constructor
Description
`ClassVisitorTee(ClassVisitor cv1, ClassVisitor cv2)`

## Method Summary

Modifier and Type
Method
Description
`void`
`visit(int version, int access, String name, String signature, String superName, String[] interfaces)`
Visits the header of the class.
`AnnotationVisitor`
`visitAnnotation(String desc, boolean visible)`
Visits an annotation of the class.
`void`
`visitAttribute(Attribute attrs)`
Visits a non standard attribute of the class.
`void`
`visitEnd()`
Visits the end of the class.
`FieldVisitor`
`visitField(int access, String name, String desc, String signature, Object value)`
Visits a field of the class.
`void`
`visitInnerClass(String name, String outerName, String innerName, int access)`
Visits information about an inner class.
`MethodVisitor`
`visitMethod(int access, String name, String desc, String signature, String[] exceptions)`
Visits a method of the class.
`void`
`visitOuterClass(String owner, String name, String desc)`
Visits the enclosing class of the class.
`void`
`visitSource(String source, String debug)`
Visits the source of the class.
`AnnotationVisitor`
`visitTypeAnnotation(int typeRef, TypePath typePath, String desc, boolean visible)`
Visits an annotation on a type in the class signature.

### Methods inherited from class org.springframework.asm.ClassVisitor

`getDelegate, visitModule, visitNestHost, visitNestMember, visitPermittedSubclass, visitRecordComponent`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Constructor Details

### ClassVisitorTee

public ClassVisitorTee(ClassVisitor cv1, ClassVisitor cv2)

## Method Details

### visit

public void visit(int version, int access, String name, String signature, String superName, String[] interfaces)
Description copied from class: `ClassVisitor`
Visits the header of the class.

Overrides:
  `visit` in class `ClassVisitor`
Parameters:
  `version` - the class version. The minor version is stored in the 16 most significant bits, and the major version in the 16 least significant bits.
  `access` - the class's access flags (see `Opcodes`). This parameter also indicates if the class is deprecated `Opcodes.ACC_DEPRECATED` or a record `Opcodes.ACC_RECORD`.
  `name` - the internal name of the class (see `Type.getInternalName()`).
  `signature` - the signature of this class. May be null if the class is not a generic one, and does not extend or implement generic classes or interfaces.
  `superName` - the internal of name of the super class (see `Type.getInternalName()`). For interfaces, the super class is `Object`. May be null, but only for the `Object` class.
  `interfaces` - the internal names of the class's interfaces (see `Type.getInternalName()`). May be null.

### visitEnd

public void visitEnd()
Description copied from class: `ClassVisitor`
Visits the end of the class. This method, which is the last one to be called, is used to inform the visitor that all the fields and methods of the class have been visited.

Overrides:
  `visitEnd` in class `ClassVisitor`

### visitInnerClass

public void visitInnerClass(String name, String outerName, String innerName, int access)
Description copied from class: `ClassVisitor`
Visits information about an inner class. This inner class is not necessarily a member of the class being visited. More precisely, every class or interface C which is referenced by this class and which is not a package member must be visited with this method. This class must reference its nested class or interface members, and its enclosing class, if any. See the JVMS 4.7.6 section for more details.

Overrides:
  `visitInnerClass` in class `ClassVisitor`
Parameters:
  `name` - the internal name of C (see `Type.getInternalName()`).
  `outerName` - the internal name of the class or interface C is a member of (see `Type.getInternalName()`). Must be null if C is not the member of a class or interface (for example, for local or anonymous classes).
  `innerName` - the (simple) name of C. Must be null for anonymous inner classes.
  `access` - the access flags of C originally declared in the source code from which this class was compiled.

### visitField

public FieldVisitor visitField(int access, String name, String desc, String signature, Object value)
Description copied from class: `ClassVisitor`
Visits a field of the class.

Overrides:
  `visitField` in class `ClassVisitor`
Parameters:
  `access` - the field's access flags (see `Opcodes`). This parameter also indicates if the field is synthetic and/or deprecated.
  `name` - the field's name.
  `desc` - the field's descriptor (see `Type`).
  `signature` - the field's signature. May be null if the field's type does not use generic types.
  `value` - the field's initial value. This parameter, which may be null if the field does not have an initial value, must be an `Integer`, a `Float`, a `Long`, a `Double` or a `String` (for `int`, `float`, `long` or `String` fields respectively). This parameter is only used for static fields. Its value is ignored for non static fields, which must be initialized through bytecode instructions in constructors or methods.
Returns:
  a visitor to visit field annotations and attributes, or null if this class visitor is not interested in visiting these annotations and attributes.

### visitMethod

public MethodVisitor visitMethod(int access, String name, String desc, String signature, String[] exceptions)
Description copied from class: `ClassVisitor`
Visits a method of the class. This method must return a new `MethodVisitor` instance (or null) each time it is called, i.e., it should not return a previously returned visitor.

Overrides:
  `visitMethod` in class `ClassVisitor`
Parameters:
  `access` - the method's access flags (see `Opcodes`). This parameter also indicates if the method is synthetic and/or deprecated.
  `name` - the method's name.
  `desc` - the method's descriptor (see `Type`).
  `signature` - the method's signature. May be null if the method parameters, return type and exceptions do not use generic types.
  `exceptions` - the internal names of the method's exception classes (see `Type.getInternalName()`). May be null.
Returns:
  an object to visit the byte code of the method, or null if this class visitor is not interested in visiting the code of this method.

### visitSource

public void visitSource(String source, String debug)
Description copied from class: `ClassVisitor`
Visits the source of the class.

Overrides:
  `visitSource` in class `ClassVisitor`
Parameters:
  `source` - the name of the source file from which the class was compiled. May be null.
  `debug` - additional debug information to compute the correspondence between source and compiled elements of the class. May be null.

### visitOuterClass

public void visitOuterClass(String owner, String name, String desc)
Description copied from class: `ClassVisitor`
Visits the enclosing class of the class. This method must be called only if this class is a local or anonymous class. See the JVMS 4.7.7 section for more details.

Overrides:
  `visitOuterClass` in class `ClassVisitor`
Parameters:
  `owner` - internal name of the enclosing class of the class (see `Type.getInternalName()`).
  `name` - the name of the method that contains the class, or null if the class is not enclosed in a method or constructor of its enclosing class (for example, if it is enclosed in an instance initializer, static initializer, instance variable initializer, or class variable initializer).
  `desc` - the descriptor of the method that contains the class, or null if the class is not enclosed in a method or constructor of its enclosing class (for example, if it is enclosed in an instance initializer, static initializer, instance variable initializer, or class variable initializer).

### visitAnnotation

public AnnotationVisitor visitAnnotation(String desc, boolean visible)
Description copied from class: `ClassVisitor`
Visits an annotation of the class.

Overrides:
  `visitAnnotation` in class `ClassVisitor`
Parameters:
  `desc` - the class descriptor of the annotation class.
  `visible` - true if the annotation is visible at runtime.
Returns:
  a visitor to visit the annotation values, or null if this visitor is not interested in visiting this annotation.

### visitAttribute

public void visitAttribute(Attribute attrs)
Description copied from class: `ClassVisitor`
Visits a non standard attribute of the class.

Overrides:
  `visitAttribute` in class `ClassVisitor`
Parameters:
  `attrs` - an attribute.

### visitTypeAnnotation

public AnnotationVisitor visitTypeAnnotation(int typeRef, TypePath typePath, String desc, boolean visible)
Description copied from class: `ClassVisitor`
Visits an annotation on a type in the class signature.

Overrides:
  `visitTypeAnnotation` in class `ClassVisitor`
Parameters:
  `typeRef` - a reference to the annotated type. The sort of this type reference must be `TypeReference.CLASS_TYPE_PARAMETER`, `TypeReference.CLASS_TYPE_PARAMETER_BOUND` or `TypeReference.CLASS_EXTENDS`. See `TypeReference`.
  `typePath` - the path to the annotated type argument, wildcard bound, array element type, or static inner type within 'typeRef'. May be null if the annotation targets 'typeRef' as a whole.
  `desc` - the class descriptor of the annotation class.
  `visible` - true if the annotation is visible at runtime.
Returns:
  a visitor to visit the annotation values, or null if this visitor is not interested in visiting this annotation.